# -*- coding: utf-8 -*-
'''
Created on 16.06.2010

@author: adm
'''
from artixds.config import Config
from artixds.domain import DiscountSystem
from sqlalchemy.orm import mapper
from artixds.mapper import DiscountSystemData, discountSystemTable
from sqlalchemy.orm import sessionmaker
from sqlalchemy import create_engine
import yaml


def loadDiscountSystem(session, discSys, secondDiscSys, bonSys, bon1Sys, update_time = None):
    resultTime = None
    discountSystems = session.query(DiscountSystemData).all()
    for sys in discountSystems:
    	if not update_time or sys.update_time != update_time:
            if sys.discsystem:
                discSys.rootCampaignGroup = yaml.load(sys.discsystem)
                discSys.loadManualCampaigns()
                discSys.loadGroupsAndCampaignsPriorities()
                discSys.number = 1
            else:
                discSys.rootCampaignGroup = None
                discSys.manualCampaigns = []
            if sys.seconddiscsystem:
                secondDiscSys.rootCampaignGroup = yaml.load(sys.seconddiscsystem)
                secondDiscSys.loadManualCampaigns()
                secondDiscSys.loadGroupsAndCampaignsPriorities()
                secondDiscSys.number = 2
            else:
                secondDiscSys.rootCampaignGroup = None
                secondDiscSys.manualCampaigns = []
            if sys.bonusearnsystem:
                bonSys.rootCampaignGroup = yaml.load(sys.bonusearnsystem)
            else:
                bonSys.rootCampaignGroup = None
                bonSys.manualCampaigns = []
            if sys.bonuslimitsystem:
                bon1Sys.rootCampaignGroup = yaml.load(sys.bonuslimitsystem)
            else:
                bon1Sys.rootCampaignGroup = None
                bon1Sys.manualCampaigns = []
            resultTime = sys.update_time
    return resultTime if resultTime else update_time

def getDiscountUpdateTime(session):
    discountSystems = session.query(DiscountSystemData.update_time).all()
    for sys in discountSystems:
        return sys.update_time
    return None

def createEngine():
    host = Config().getString("MysqlServer", "host", "localhost")
    port = Config().getString("MysqlServer", "port", "3306")
    user = Config().getString("MysqlServer", "user", "root")
    password = Config().getString("MysqlServer", "password", "")
    return create_engine('mysql://%s:%s@%s:%s/dictionaries?charset=utf8' % (user, password, host, port), echo=True)

def loadDiscountSystemLegacy():
    mapper(DiscountSystemData, discountSystemTable) 
    engine = createEngine()
    Session = sessionmaker(autoflush=True, autocommit=True)
    Session.configure(bind=engine)
    session = Session()
    discSys, bonSys, bonpSys = None, None, None
    discountSystems = session.query(DiscountSystemData).all()
    for sys in discountSystems:
        discSys = DiscountSystem()
        discSys.rootCampaignGroup = yaml.load(sys.discsystem)
    return discSys, bonSys, bonpSys

def loadDiscountSystemSimple():
    mapper(DiscountSystemData, discountSystemTable) 
    engine = createEngine()
    Session = sessionmaker(autoflush=True, autocommit=True)
    Session.configure(bind=engine)
    session = Session()
    discSys, bonSys, bonpSys = None, None, None
    discountSystems = session.query(DiscountSystemData).all()
    for sys in discountSystems:
        discSys = DiscountSystem()
        discSys.rootCampaignGroup = yaml.load(sys.discsystem)
    return discSys, bonSys, bonpSys

def createSession():
    mapper(DiscountSystemData, discountSystemTable) 
    engine = createEngine()
    Session = sessionmaker(autoflush=True, autocommit=True)
    Session.configure(bind=engine)
    return Session()

session = createSession()
